//holds data on window size
function mapApp() {
	if (!document.documentElement.getScreenCTM) {
		this.resetFactors();
		//add resize event to document element
		document.documentElement.addEventListener("SVGResize",this,false);
	}
}

mapApp.prototype.handleEvent = function(evt) {
	if (evt.type == "SVGResize") {
		this.resetFactors();
	}
}

mapApp.prototype.resetFactors = function() {
	if (!document.documentElement.getScreenCTM) {
		//case for viewers that don't support .getScreenCTM, such as ASV3
		//calculate ratio and offset values of app window
		var viewBoxArray = document.documentElement.getAttributeNS(null,"viewBox").split(" ");
		var myRatio = viewBoxArray[2]/viewBoxArray[3];
		if ((window.innerWidth/window.innerHeight) > myRatio) { //case window is more wide than myRatio
			this.scaleFactor = viewBoxArray[3] / window.innerHeight;
		}
		else { //case window is more tall than myRatio
			this.scaleFactor = viewBoxArray[2] / window.innerWidth;
		}
		this.offsetX = (window.innerWidth - viewBoxArray[2] * 1 / this.scaleFactor) / 2;
		this.offsetY = (window.innerHeight - viewBoxArray[3] * 1 / this.scaleFactor) / 2;
	}
}

mapApp.prototype.calcCoord = function(evt,ctmNode) {
	var svgPoint = document.documentElement.createSVGPoint();
	svgPoint.x = evt.clientX;
	svgPoint.y = evt.clientY;
	if (!document.documentElement.getScreenCTM) {
		//case ASV3 a. Corel
		svgPoint.x = (svgPoint.x  - this.offsetX) * this.scaleFactor;
		svgPoint.y = (svgPoint.y - this.offsetY) * this.scaleFactor;
		//undo the effect of transformations
		if (ctmNode) {
			var ctm = getTransformToRootElement(ctmNode).inverse();
		}
		else {
			var ctm = getTransformToRootElement(evt.target).inverse();			
		}
		svgPoint = svgPoint.matrixTransform(ctm);

	}
	else {
		if (ctmNode) {
			var matrix = ctmNode.getScreenCTM();
		}
		else {
			var matrix = evt.target.getScreenCTM();		
		}
     	svgPoint = svgPoint.matrixTransform(matrix.inverse());
	}
	return svgPoint;
}